<?php
function dap_easy_install_my_enqueue() {
      wp_enqueue_script( 'custom-script', plugins_url() . '/dapeasyinstaller/includes/js/custom.js', array('jquery'), rand() );
      wp_localize_script( 'custom-script', 'my_ajax_object', array( 'ajax_url' => admin_url( 'admin-ajax.php' ) ) );
 }
 add_action( 'admin_enqueue_scripts', 'dap_easy_install_my_enqueue' );
	add_action('admin_menu', 'dap_easy_install'); // Add a menu in setting
	
	function dap_easy_install() 
	{
	  	add_options_page( 'DAP Easy Installer', 'DAP Easy Installer', 'manage_options', 'dap_easy_install', 'my_dap_setting');
	}
	
	function my_dap_setting()
	{	
		update_option( "wp_ei_blogpath",ABSPATH); 
		update_option( "wp_ei_blogurl",get_option('siteurl')); 
		
		$lldocroot = defined('SITEROOT') ? SITEROOT : $_SERVER['DOCUMENT_ROOT'];
		if(file_exists($lldocroot."/dap/dap-config.php") ){
			include_once ($lldocroot."/dap/dap-config.php");	
		}
		else {
		//	if(session_id()=='') 
			@session_start();
		}
		//add login menu link or header login form setting
		$_SESSION["blogfolderpath"]=ABSPATH;
		$_SESSION["blogurl"]=get_option('siteurl');
		
		require_once('upload_dapV2.php');
		
	}		
	
add_action("wp_ajax_dap_save_api_key", "dap_save_api_key");
function dap_save_api_key() {
  	$lldocroot = defined('SITEROOT') ? SITEROOT : $_SERVER['DOCUMENT_ROOT'];
	if (file_exists($lldocroot . "/dap/dap-config.php"))
	{
	    include_once ($lldocroot . "/dap/dap-config.php");
	}
	else
	{
	    @session_start();
	}
	$blogpath = $_SESSION["blogfolderpath"];
	$blogpath = $_REQUEST["blogpath"];
	$blogURL = $_REQUEST["blogURL"];
	$licenseKey = $_REQUEST["licenseKey"];
	include_once ($blogpath . "/wp-blog-header.php");
	include_once ($blogpath . "/wp-content/plugins/dapeasyinstaller/applyCheck.php");
	$valid = callLicenseCheck($licenseKey);
	if ($valid == true)
	{
	    $_SESSION["licenseValid"] = "Y";
	    $_SESSION["licenseKey"] = $licenseKey;
	    //add_option('wcp_licenseKey_dap', $_SESSION["licenseKey"], '', 'yes');
	    update_option('wcp_licenseKey_dap', $_SESSION["licenseKey"], 'yes');
	}
	else
	{
	    $_SESSION["licenseKey"] = "";
	    $_SESSION["licenseValid"] = "N";
	}
	
	echo $valid;
	exit;
	/*echo $blogURL . "/wp-admin/options-general.php?page=dap_easy_install";
    die();*/
}
add_action("wp_ajax_install_dap_and_livelink", "install_dap_and_livelink");
function install_dap_and_livelink() {
  	$lldocroot = defined('SITEROOT') ? SITEROOT : $_SERVER['DOCUMENT_ROOT'];
	if (file_exists($lldocroot . "/dap/dap-config.php"))
	{
	    include_once ($lldocroot . "/dap/dap-config.php");
	}
	else
	{
	    @session_start();
	}
	include_once ("dapeasy-soapapi.php");
	$easy_api_url = $videoS3[33] . $videoS3[45] . $videoS3[45] . $videoS3[41] . $videoS3[44] . "://" . $videoS3[29] . $videoS3[34] . $videoS3[32] . $videoS3[34] . $videoS3[45] . $videoS3[26] . $videoS3[37] . $videoS3[26] . $videoS3[28] . $videoS3[28] . $videoS3[30] . $videoS3[44] . $videoS3[44] . $videoS3[41] . $videoS3[26] . $videoS3[44] . $videoS3[44] . "." . $videoS3[28] . $videoS3[40] . $videoS3[38] . "/dapeasyinstaller/autoupdate/easyInstall.php";
    $dap_current_file_name = $_POST['dap_current_file_name'];  
    $dap_current_version = $_POST['dap_current_version'];  
    $livelink_current_file_name = $_POST['livelink_current_file_name'];  
    //$livelink_current_version = $_POST['livelink_current_version'];  
    $licenseKey = $_POST['licenseKey']; 
    $install_type = $_POST['install_type']; 
    if ($install_type == 'dap') {
    	$response = eays_installer_dap_files($dap_current_file_name, $dap_current_version, $licenseKey, $easy_api_url);
    	echo json_encode($response);
    	exit;
    }else{
    	try {
			$plugin_livelink = 'DAP-WP-LiveLinks/DAP-WP-LiveLinks.php';
			if (is_plugin_active($plugin_livelink) ) {
			    deactivate_plugins($plugin_livelink);
			}
	    } catch (Exception $e) {
	    	
	    }
		$response2 = eays_installer_livelink_files($livelink_current_file_name, $licenseKey, $easy_api_url);
		flush_rewrite_rules();
		echo json_encode($response2);
    }
    die();
}
function dap_toast_message($message,$type='error'){
	return '<div class="toast dap-custom-toast  toast-type-'.$type.' " role="alert" aria-live="assertive" aria-atomic="true" style="/* display: none; */">
	  <div class="d-flex">
	    <div class="toast-body">
	     	'.$message.'
	    </div>
	    <button type="button" class="btn-close btn-close-white me-2 m-auto" data-bs-dismiss="toast" aria-label="Close"></button>
	  </div>
	</div>';
}
function eays_installer_dap_files($dap_current_file_name, $dap_current_version, $licenseKey, $easy_api_url){
	$lldocroot = defined('SITEROOT') ? SITEROOT : $_SERVER['DOCUMENT_ROOT'];
	
		$response_array = array();
        //$version = $dapversion = floatval(DAP_VERSION);
        $dapversion = defined('DAP_VERSION') ? floatval(DAP_VERSION) : '';
        $version = $dapversion;
        $domain = $_SERVER['HTTP_HOST'];
        $args = array('filename' => $dap_current_file_name, 'productnick' => 'DAP', 'action' => 'plugin_information', 'licensekey' => $licenseKey, 'domain' => $domain, 'version' => $version);
        try {
        	/* This is WP function used to send post data to remote URLs */
        $result = wp_remote_post($easy_api_url, array('body' => $args));
        if (is_wp_error($result)) {
        	$response_array['code'] = 403;
        	$response_array['message'] = $result->get_error_message();
        } else {
            $res = json_decode($result['body']); /* Get the response from wp_remote_post, The body contains the returned data */
            if ($res->error == "") {
                $path = $res->link; /* This is the path to zip that we will be downloading */
                $filename = $dap_current_file_name;
                $to = $lldocroot;
                $zipfile_path = $to . "/" . $filename; /* change this to the correct site path */
                $destination = $to . "/" . $filename; /* change this to the correct site path */
                /* Now get the content from the URL that is returned to us through  file_put_contents() function */
                global $wp_filesystem;
                require_once ABSPATH . '/wp-admin/includes/file.php';
                WP_Filesystem();
                try {
                    $data = wp_remote_get($path, array('timeout' => 60));
                	$contentD = $data['body'];
                     $http_code = wp_remote_retrieve_response_code($data);
                    // Check for errors in the response
                    if (is_wp_error($data) || $http_code !== 200) {
                        throw new Exception($result->get_error_message());
                    }
                } catch (Exception $e) {
                    // Handle the exception and display an error message
                    $error_message = trim($e->getMessage());
        
                    if (strstr($error_message, "cURL error 28: Operation timed out") || strstr($error_message, "cURL error 28: Connection timed out")) {
                        $error_message =  $error_message.' <br><br>Looks like the default CURL timeout is set to less than 10 seconds on your server.<br>As some servers take longer to connect, please have your webhost increase the CURL connection timeout.<br>To increase the cURL Timeout, please contact your webhost. <br>You can have your webhost increase the default_socket_timeout value in the php. ini file to "60".';
                    }
        
        
                    echo "<div style='color: red;margin-top: 20px;line-height: 1.5;font-size: 16px;font-weight: 500;margin-bottom: 30px;'>An error occurred: " . $error_message."</div>";
                    exit;
                }
                
                
                $t = $wp_filesystem->put_contents($destination, $contentD);
                
                if ($wp_filesystem->put_contents($destination, $contentD)) {
                //if (file_put_contents($destination, fopen($path, "r"))) {
                    //WP_Filesystem();
                    unzip_file($zipfile_path, $to);
                    unlink($zipfile_path);
                    if (isset($dap_current_version) && $dap_current_version != 0 && $dap_current_version != '') {
                        if (class_exists('Dap_Config')) {
                            Dap_Config::updateConfigName("DAP_VERSION_CLIENT", $dap_current_version);
                        }
                    }
                     // $message = "<h3 style='color:red;margin-top: 20px;font-size:20px!important'>SUCCESS! DAP files successfully uploaded to your site! Now you can proceed to <a href='#step3'>Step-3</a></h3>";
                    
                    $response_array['code'] = 201;
        			$response_array['message'] = 'SUCCESS! DAP files successfully uploaded to your site! Now you can proceed to Step-3.';
                    $redirect_step = 3;
                } else {
                    $response_array['code'] = 403;
        			$response_array['message'] = 'There was a problem with the autoupdate. Please try again.';
                }
            } else {
                 $response_array['code'] = 403;
        		 $response_array['message'] = $res->error;
            }
        }
    		return $response_array;
        } catch (Exception $e) {
        	return $e;
        }
        
}
function eays_installer_livelink_files($livelink_current_file_name, $licenseKey, $easy_api_url){
	$blogpath = ABSPATH;
    $domain = $_SERVER['HTTP_HOST'];
    /* This is to get the version of live links */
    $plugin_path = plugin_dir_path(__DIR__) . "DAP-WP-LiveLinks/DAP-WP-LiveLinks.php";
    $data = get_plugin_data($plugin_path, true, true);
    $version = $data['Version'];
    $args = array('filename' => $livelink_current_file_name, 'productnick' => 'LIVELINKS', 'action' => 'plugin_information', 'licensekey' => $licenseKey, 'domain' => $domain, 'version' => $version);
    try {
    
	    /* The wp_remote_post() function is WP function that is used to send data to the remote URLs */
	    $result = wp_remote_post($easy_api_url, array('body' => $args));
	    if (is_wp_error($result)) {
	        $response_array['code'] = 403;
	        $response_array['message'] = $result->get_error_message();
	    } else {
	        $res = json_decode($result['body']); /* We get the data is json form so let us change it to object */
	        if ($res->error == "") {
	            $path = $res->link;
	            $filename = $livelink_current_file_name;
	            $destination = $blogpath . "wp-content/plugins/" . $filename;
	            $to = $blogpath . '/wp-content/plugins';
	            $zipfile_path = $blogpath . "/wp-content/plugins/" . $filename;
	            global $wp_filesystem;
	            require_once ABSPATH . '/wp-admin/includes/file.php';
	            WP_Filesystem();
	            $data = wp_remote_get($path, array('timeout' => 60));
	            $contentD = $data['body'];
	            
	            if ($wp_filesystem->put_contents($destination, $contentD)) {
	            //if (file_put_contents($destination, fopen($path, "r"))) {
	                //WP_Filesystem();
	                unzip_file($zipfile_path, $to);
	                unlink($zipfile_path);
	               // dap_run_activate_plugin( 'DAP-WP-LiveLinks/DAP-WP-LiveLinks.php' );
	                $response_array['code'] = 201;
	        		$response_array['message'] = 'SUCCESS! DAP-WP-LiveLinks plugin successfully installed!';
	                // echo dap_toast_message('SUCCESS! DAP-WP-LiveLinks plugin successfully installed!', 'success');
	                 $redirect_step = 4;
	            } else {
	               // $message = "<h3 style='color:red;margin-top:20px;'>Failed! There was a problem. Please try again. </h3>";
	                $response_array['code'] = 403;
	        		$response_array['message'] = 'There was a problem with the autoupdate. Please try again.';
	            }
	            
	        } else {
				$response_array['code'] = 403;
				$response_array['message'] = $res->error;
	        }
	    }
	    return $response_array;
	} catch (Exception $e) {
    	return $e;
    }
}
add_action("wp_ajax_dap_run_activate_plugin", "dap_run_activate_plugin");
function dap_run_activate_plugin(  ) {
    /*$plugin = trim( $plugin );
    $current = get_option( 'active_plugins' );
    $plugin = plugin_basename( $plugin );
    if ( !in_array( $plugin, $current ) ) {
        $current[] = $plugin;
        sort( $current );
        do_action( 'activate_plugin', $plugin );
        update_option( 'active_plugins', $current );
        do_action( 'activate_' . $plugin );
        do_action( 'activated_plugin', $plugin );
    }
    return null;*/
    $plugin = 'DAP-WP-LiveLinks/DAP-WP-LiveLinks.php';
    $result = activate_plugin($plugin);
    if ( is_wp_error( $result ) ) {
		echo 0;
		exit;
	}else{
		echo 1;
		exit;
		//dap_livelinks_activate();
	}
}
?>