jQuery(document).ready(function() {
    jQuery('form#dapformlicense').on('submit', function (e) {
        jQuery('.btn-action-wrapper').hide();
        jQuery('.btn-loader-wrapper').show();
        e.preventDefault();
        var ajaxurl = my_ajax_object.ajax_url;
        var licenseKey = jQuery('#licenseKey').val();
        var blogURL = jQuery('#blogURL').val();
        var blogpath = jQuery('#blogpath').val();
        jQuery.ajax({
            url: ajaxurl,
            type:'POST',
            data:{
                action : 'dap_save_api_key',        
                licenseKey : licenseKey,        
                blogURL : blogURL,      
                blogpath : blogpath,        
                
            } , 
            success: function(response){
              jQuery('.btn-action-wrapper').show();
              jQuery('.btn-loader-wrapper').hide();
                 jQuery('#dapformlicense').remove('.easy-installer-error');
                 jQuery('form#dapformlicense input[type="submit"]').val('Save License');
                if (response) {
                     location.reload();
                 }else{
                    jQuery('#dapformlicense').after('<span class="easy-installer-error">Sorry, this is not a valid license.</span>');
                 }
               // window.location.href = response;
            }
        });
    });
    jQuery('a[href="#step3"]').on('click',function(e){
        setInterval(function(){ history.pushState("", document.title, window.location.pathname + window.location.search); }, 3000);
    });
  jQuery('.toast.dap-custom-toast').delay(10000).fadeOut('slow'); 
  var redirect_step = jQuery('#redirect_step').val();
  jQuery('.upload-form-outer').removeClass('active-tab');
  jQuery('.upload-form-outer.step-'+redirect_step).addClass('active-tab');
  jQuery('.circle').removeClass('active');
  jQuery('.circle.step-'+redirect_step).addClass('active');
  if (redirect_step != 1) {
    jQuery('#ei_dap_prev').removeAttr('disabled')
  }
  if (redirect_step == 4) {
    jQuery('#ei_dap_next').attr('disabled', 'disabled');
  }
  var dap_version = jQuery('.upload-selectoption.dap_version_downgrade_or_upgrade').find(":selected").attr('data-dapversion');
  if (typeof dap_version != 'undefined') {
    var current_version = dap_version.substring(0, dap_version.indexOf("."));
    var livelink_version = current_version - 3;
    var livelink_version_final = dap_version.replace(current_version, livelink_version);
    livelink_version_final = 'DAP-WP-LiveLinks_v'+livelink_version_final+'.zip';
    jQuery('select.upload-selectoption.livelink_version_downgrade_or_upgrade').val(livelink_version_final );
  }
 
  
  jQuery(".ei-dap-popup img").click(function () {
      var src = jQuery(this).attr("src");
      jQuery(".ei-dap-popup-show").show();
      jQuery(".img-ei-dap-popup-show img").attr("src", src);
  });
  jQuery("span, .ei-dap-popup-overlay").click(function () {
      jQuery(".ei-dap-popup-show").hide();
  });
  jQuery(document).on('click', 'div.circle',function(){
      jQuery(".circle").removeClass('active');
      jQuery(".upload-form-outer").removeClass('active-tab');
      jQuery(this).addClass('active');
      var selected_id = jQuery(this).attr('data-id');
      jQuery('.upload-form-outer.step-'+selected_id).addClass('active-tab');
    jQuery('.step-area-container .btn').removeAttr('disabled')
    if (selected_id == 1) {
      jQuery('#ei_dap_prev').attr('disabled', 'disabled');
    }else if (selected_id == 4) {
      jQuery('#ei_dap_next').attr('disabled', 'disabled');
    }
    
  });
  jQuery('.dap-installer-process-btn').on('click', function (e) {
    jQuery('.dap-installer-process-btn').hide();
    jQuery('.dap-process-btn-loader').css('display', 'flex');

    
    
   dap_ie_download_dap_livelinks('dap');
    

  });
jQuery('#ei_dap_next').click(function() {
  jQuery('.active-tab').removeClass('active-tab').next().addClass('active-tab');
    jQuery('.circle.active').removeClass('active').next().addClass('active');
  if (jQuery('.active-tab').hasClass('last-tab')) {
    jQuery('#ei_dap_next').attr('disabled', 'disabled');
  }
  jQuery('#ei_dap_prev').removeAttr('disabled');
  
});
jQuery('#ei_dap_prev').click(function() {
  jQuery('.active-tab').removeClass('active-tab').prev().addClass('active-tab');
  jQuery('.active').removeClass('active').prev().addClass('active');
  
  if (jQuery('.active-tab').hasClass('first-tab')) {
    jQuery('#ei_dap_prev').attr('disabled', 'disabled');
  }
  jQuery('#ei_dap_next').removeAttr('disabled');
});
});
jQuery(document).on('click',".toast.dap-custom-toast .btn-close",function(){
  jQuery('.toast.dap-custom-toast').hide();
  jQuery('.toast.dap-custom-toast .toast-body').html('');
});
  
jQuery(window).on('load', function(){
  jQuery('#loadingdiv').hide();
});


function dap_ie_download_dap_livelinks(install_type){
    var dap_current_file_name= jQuery("select.upload-selectoption.dap_version_downgrade_or_upgrade option:first-child").val();
    var dap_current_version = jQuery("select.upload-selectoption.dap_version_downgrade_or_upgrade option:first-child").attr('data-dapversion');
    var licenseKey = jQuery("#licenseKey").val();
   
    var livelink_current_file_name = jQuery("select.upload-selectoption.livelink_version_downgrade_or_upgrade option:first-child").val();
    var livelink_current_version = jQuery("select.upload-selectoption.livelink_version_downgrade_or_upgrade option:first-child").attr('data-dapversion');
    jQuery('.dap-process-msg').show();
  var ajaxurl = my_ajax_object.ajax_url;
    jQuery.ajax({
      url: ajaxurl,
      type:'POST',
      data:{
        action : 'install_dap_and_livelink',
        dap_current_file_name:dap_current_file_name,
        dap_current_version:dap_current_version,
        livelink_current_file_name:livelink_current_file_name,
        livelink_current_version:livelink_current_version,
        licenseKey:licenseKey,
        install_type:install_type
      }, 
      success: function(response){
        jQuery('.dap-process-msg').hide();
        response = JSON.parse(response);
        if (response.code == 201) {
          if (install_type == 'dap') {
            dap_ie_download_dap_livelinks('livelinks');
          }
          if (install_type == 'livelinks') {
           jQuery.ajax({
              url: ajaxurl,
              type:'POST',
              data:{
                action : 'dap_run_activate_plugin'
              }, 
              success: function(response){
                jQuery('.dap-process-msg').hide();
                response = JSON.parse(response);
                if (response) {
                  jQuery('.dap-easy-installer-products').addClass('dap-success-wrapper');
                  jQuery('.dap-connect-screen').removeClass('show-screen');
                }else{
                  alert(response.message);
                  jQuery('.dap-installer-process-btn').html('Click Here to Install DAP');
                  jQuery('.dap-installer-process-btn').show();
                  jQuery('.dap-process-btn-loader').hide();
               }
              },
              error: function (xhr, ajaxOptions, thrownError) {
                jQuery('.dap-process-msg').hide();
                alert('Something went wrong please try again');
              }
            });
          }
         
        }else{
          alert(response.message);
          jQuery('.dap-installer-process-btn').html('Click Here to Install DAP');
          jQuery('.dap-installer-process-btn').show();
          jQuery('.dap-process-btn-loader').hide();
       }
       return response.code;
      },
      error: function (xhr, ajaxOptions, thrownError) {
        jQuery('.dap-process-msg').hide();
        alert('Something went wrong please try again');
      }
    });
}